#!/usr/bin/perl
use ISY::Simple;

# Send a command to an Insteon / X10 device via an ISY init
#
# Peter Shipley <peter.shipley@gmail.com>

use Getopt::Long;
use strict;

use Data::Dumper;
$Data::Dumper::Indent = 1;         # pretty print with array indices

# --climate
# --nodenames
# --nodes
# --comm <n> <c>
# --x10  <u> <c>

my $host="10.1.1.36";
my $verbose=2;
my $namenodes=1;
my @userfilter;
my @typefilter;
my $help;

sub main {

    print "isy main\n";

    my $node = shift @ARGV;

    my $comm = shift @ARGV if @ARGV;

    my $isy = ISY::Simple->new(
	host =>  $host,
	verbose => $verbose,
	faststart => "1",
	debug => "3",
    );

    unless ( $isy ) {
	print "new failed\n";
	exit(0);
    }

    do_comm($isy, $node, $comm, @ARGV);

}

sub do_comm {

my ($isy, $n, $c, @a) = @_;

    if ( $c ) {
	if ( $n =~ /^[A-P]\d{1,2}$/ ) {
	    unless ( $isy->x10_comm($n, $c) ) {
		 print "Error : $n : ", $isy->{error}, "\n";
	    }
	} else {
	    unless ( $isy->node_comm($n, $c, @a) ) {
		 print "Error : $n : ", $isy->{error}, "\n";
	    }
	    # my $r = $isy->node_query($n);
	    # print "=== xurl : \n", Dumper($r), "\n";


	}

    } else {
	    my $r = $isy->node_query($n);
	    #print "=== $n : \n", Dumper($r), "\n";

	    my $state = $r->{ST}->{formatted};
	    $state .= "%" unless ( $state =~ /^[O\s]/ );

	    print "$n is $state\n";

    }

}




&main();
exit(0);
